<?php

namespace Drupal\views_add_button_group\Plugin\views_add_button;

use Drupal\Core\Plugin\PluginBase;
use Drupal\Core\Url;
use Drupal\views_add_button\ViewsAddButtonInterface;

/**
 * @ViewsAddButton(
 *   id = "views_add_button_group_content",
 *   label = @Translation("ViewsAddButtonGroup"),
 *   target_entity = "group_content"
 * )
 */
class ViewsAddButtonGroupContent extends PluginBase implements ViewsAddButtonInterface {

  /**
   * @return string
   *   A string description.
   */
  public function description()
  {
    return $this->t('Views Add Button URL Generator for Group Content entities');
  }

  public static function checkAccess($entity_type, $bundle, $context) {
    // TODO add access callback for this entity
    return TRUE;
  }

  public static function generate_url($entity_type, $bundle, $options, $context = '') {
    // We are expecting a bundle of the type group-group_[entity_type]-[entity_type_bundle]
    $c  = explode('-', $bundle);
    $plugin_id = count($c) === 3 ? implode(':', array($c[1], $c[2])) : '';
    // Create URL from the data above
    if ($context && $plugin_id) {
      $url = Url::fromRoute('entity.group_content.create_form', array('group' => $context, 'plugin_id' => $plugin_id), $options);
      return $url;
    }
  }

}